package sun.corba;

import com.sun.corba.se.impl.io.ValueUtility;
import sun.misc.JavaOISAccess;
import java.lang.reflect.Method;
import sun.misc.Unsafe;

public class SharedSecrets
{
    private static final Unsafe unsafe;
    private static JavaCorbaAccess javaCorbaAccess;
    private static final Method getJavaOISAccessMethod;
    private static JavaOISAccess javaOISAccess;
    
    public SharedSecrets() {
    }
    
    public static JavaOISAccess getJavaOISAccess() {
        if (SharedSecrets.javaOISAccess == null) {
            try {
                SharedSecrets.javaOISAccess = (JavaOISAccess)SharedSecrets.getJavaOISAccessMethod.invoke(null, new Object[0]);
            }
            catch (Exception thrown) {
                throw new ExceptionInInitializerError(thrown);
            }
        }
        return SharedSecrets.javaOISAccess;
    }
    
    public static JavaCorbaAccess getJavaCorbaAccess() {
        if (SharedSecrets.javaCorbaAccess == null) {
            SharedSecrets.unsafe.ensureClassInitialized(ValueUtility.class);
        }
        return SharedSecrets.javaCorbaAccess;
    }
    
    public static void setJavaCorbaAccess(JavaCorbaAccess javaCorbaAccess) {
        SharedSecrets.javaCorbaAccess = javaCorbaAccess;
    }
    
    static {
        unsafe = Unsafe.getUnsafe();
        try {
            getJavaOISAccessMethod = Class.forName("sun.misc.SharedSecrets").getMethod("getJavaOISAccess", new Class[0]);
        }
        catch (Exception thrown) {
            throw new ExceptionInInitializerError(thrown);
        }
    }
}
